clear;clc;close all

% Set up function to integrate
F=@(x,y,z) (x.^2.*y.^7.*z.^5);

% Set up limits for integration
xmin=0;
xmax=1;
ymin=0;
ymax=1;
zmin=0;
zmax=1;

% tolerance for numerical integration
tol=1e-10;

% Numerical triple integral
tic;
Q_num = triplequad(F,xmin,xmax,ymin,ymax,zmin,zmax,tol);
t_num=toc;

string = sprintf ('%12s %12s %12s %12s %12s %12s ', 'Q_num', 'Q_mc', 't_num', 't_mc', 't_mc/t_num', 'N', '% error');
disp(string)

% Choose different values for N
for i=1:7

    N=10^i;
    
    tic;
    Q_mc=MonteCarlo(F, [xmin xmax ymin ymax zmin zmax], N);
    t_mc=toc;
    t(i)=t_mc;
    
    p_err=100*(Q_num-Q_mc)/Q_num;

    string = sprintf ('%12.3g %12.3g %12.3g %12.3g %12.3g %12.3g %12.3g ', Q_num, Q_mc, t_num, t_mc, t_mc/t_num, N, p_err);
    disp(string)
    
end